<template>
  <div class="document-input d-flex flex-wrap">
    <v-select
      class="flex-grow-1 flex-sm-grow-0 document-type mr-2"
      v-bind="$attrs"
      v-model="type"
      clearable="clearable"
      label="Tipo Documento"
      :items="supportedTypes"
      :item-value="(item) =&gt; item"
      item-text="name"
     />    <v-text-field
      class="flex-grow-1"
      v-bind="$attrs"
      v-model="val"
      :disabled="!type || type.id === 'NONE'"
      :label="(type &amp;&amp; type.name) || 'Selecione o tipo do documento'"
      v-mask="(type &amp;&amp; type.mask) || []"
     />  </div>
</template>

<script lang="ts">
import Vue from 'vue'

import vRequired from '@/validators/required'

export interface IDocumentType {
  id: string,
  name: string,
  mask: string
}

const supportedTypes: IDocumentType[] = [
  {
    id: 'CPF',
    name: 'CPF',
    mask: '###.###.###-##'
  },
  {
    id: 'CNH',
    name: 'CNH',
    mask: '###########'
  },
  {
    id: 'RG',
    name: 'RG',
    mask: 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'
  },
  {
    id: 'SUS',
    name: 'Número SUS',
    mask: '### #### #### #### #'
  },
  {
    id: 'Other',
    name: 'Other',
    mask: 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'
  }
]

export default Vue.extend({
  name: 'DocumentInput',
  props: {
    value: { type: Object, default: null }
  },
  data: () => ({
    type: null as IDocumentType | null,
    val: null as string | null,
    freeform: null as string | null,

    supportedTypes,
    vRequired
  }),
  watch: {
    type () {
      this.val = null

      this.updated()
    },
    value () {
      if (this.value === null) {
        this.val = null
        this.type = null
      }
    },
    val () {
      this.updated()
    },
    freeform () {
      this.updated()
    }
  },
  methods: {
    updated () {
      this.$emit(
        'input',
        this.type && {
          type: this.type && this.type.id,
          value: this.type && this.type.mask ? this.val : this.freeform
        }
      )
    }
  }
})
</script>

<style lang="scss" scoped>
.document-type {
  width: 10em;
}
</style>
